/***************************************
 *            ViPER                    *
 *  The Video Processing               *
 *         Evaluation Resource         *
 *                                     *
 *  Distributed under the GPL license  *
 *        Terms available at gnu.org.  *
 *                                     *
 *  Copyright University of Maryland,  *
 *                      College Park.  *
 ***************************************/


package edu.umd.cfar.lamp.viper.examples.omegahead;

import java.util.*;

import edu.umd.cfar.lamp.viper.geometry.*;

/**
 * @author davidm
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class OmegaHeadModel {
	private Pnt centroid;
	private int lineLength;
	private int diameter;
	private int orientation;
	
	/**
	 * @param centroid
	 * @param width
	 * @param height
	 * @param orientation
	 */
	public OmegaHeadModel(Pnt centroid, int lineLength, int diameter, int orientation) {
		super();
		assert centroid != null;
		this.centroid = centroid;
		this.lineLength = lineLength;
		this.diameter = diameter;
		this.orientation = orientation;
	}
	
	public OmegaHeadModel(int[] data) {
		this(new Pnt(data[0], data[1]), data[2], data[3], data[4]);
	}
	
	public Pnt getCentroid() {
		return centroid;
	}
	public int getDiameter() {
		return diameter;
	}
	public int getOrientation() {
		return orientation;
	}
	public int getLineLength() {
		return lineLength;
	}
	
	/**
	 * @param s
	 * @return
	 * @throws IllegalArgumentException
	 */
	public static Object valueOf(String s) {
		int[] data = new int[5];
		try {
			StringTokenizer st = new StringTokenizer(s);
			for (int i = 0; i < 5; i++)
				data[i] = Integer.parseInt(st.nextToken());
			data[4] = data[4] % 360;
		} catch (NumberFormatException nfx) {
			throw new IllegalArgumentException("That wasn't a number - " + s);
		} catch (NoSuchElementException nsex) {
			throw new IllegalArgumentException("Not enough numbers in obox - " + s);
		}
		return new OmegaHeadModel(data);
	}

	public String toString() {
		return centroid.getX() + " " + centroid.getY() + " " + lineLength + " " + diameter + " " + orientation; 
	}
}
